##############################################################################
#
# Copyright (c) 2001 Alexandre Fernandez (alex@grotte.org). All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE
#
#############################################################################
from elementtree.ElementTree import fromstring, tostring
from elementtree.ElementTree import Element, SubElement
from Avatar import Avatar
import time, random, re, string


def do_pong(socket, element, world):
    
    nickname = element.attrib.get('nickname', \
               str(random.random()).split('.')[1])
        
    newAvatar = Avatar(socket, nickname)
    mainRoom = world.getMainRoom()
    world.born(newAvatar, mainRoom)
    world.delPending(socket)

    welcome = Element('welcome')
    welcome_xml = tostring(welcome)
    newAvatar.send(welcome_xml)
    del welcome_xml
    del welcome
    
pending_handlers = {}
pending_handlers['pong'] = do_pong

def parsePendingCommand(socket, data, world):
    try:
        data = string.replace(data,'\x00', '') 
        element = fromstring(data)
        command = pending_handlers[element.tag.lower()]
        command(socket, element, world)
        del element
    except:
        print "parse error on pending command %s" % data
    



