##############################################################################
#
# Copyright (c) 2004 Alexandre Fernandez (alex@grotte.org). All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE
#
##############################################################################
"""
This module content room definitions
XXX: have to write documentation about room
"""

class Room:
    """
    A room is a place where avatars can chat
    """
    id = None
    content = []
    myWorld = None

    def __init__(self, room_id , world):
        self.id = room_id
        self.content = []
        self.myWorld = world
        world.addRoom(self)

    def getId(self):
        return self.id
    
    def join(self, avatar):
        if not self.content.count(avatar):
            self.content.append(avatar)
	    self.send('<join from="%s"/>' % avatar.getNickname())

    def part(self, avatar):
        self.content.remove(avatar)
	self.send('<part from="%s"/>' % avatar.getNickname())

    def send(self, message):
        for avatar in self.content:
            avatar.send(message)

    def __del__(self):
        for avatar in self.content:
            del avatar

        del self.content
        del self.id

    def getAvatars(self):
        return self.content

    def getWorld(self):
        return self.myWorld

  
    def getAvatarByNickname(self, nickname):
        for avatar in self.content:
            if avatar.getNickname().upper() == nickname.upper():
                return avatar

        return None
